Use debhelper 12.

This commit is contained in:
Timo Aaltonen 2020-01-31 20:03:23 +02:00
parent ca45cb561a
commit 48de9f41ad
7 changed files with 7 additions and 946 deletions

1
debian/changelog vendored
View File

@ -6,6 +6,7 @@ x11-xserver-utils (7.7+9) UNRELEASED; urgency=medium
* xrandr 1.5.1. (Closes: #784324)
* xrdb 1.2.0.
* xstdcmap 1.0.4.
* Use debhelper 12.
-- Timo Aaltonen <tjaalton@debian.org> Fri, 31 Jan 2020 13:58:50 +0200

1
debian/compat vendored
View File

@ -1 +0,0 @@
9

3
debian/control vendored
View File

@ -3,8 +3,7 @@ Section: x11
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Build-Depends:
debhelper (>= 9),
dh-autoreconf,
debhelper-compat (= 12),
pkg-config,
x11proto-core-dev (>= 7.0.25),
libx11-dev (>= 2:1.0.0),

9
debian/rules vendored
View File

@ -10,8 +10,6 @@
# set this to the name of the main shlib's binary package
PACKAGE = x11-xserver-utils
include debian/xsfbs/xsfbs.mk
# This package contains multiple modules as shipped by upstream. Each module is # contained in a subdirectory in the root dir of the package. You must list each
# subdirectory explicitly so that the build system knows what to build
DEF_SUBDIRS=iceauth rgb sessreg xcmsdb xgamma xhost xmodmap xrandr xrdb xrefresh xset xsetmode xsetpointer xsetroot xstdcmap xvidtune
@ -20,7 +18,7 @@ CONFIG_STAMPS = $(addprefix $(STAMP_DIR)/configure-, $(SUBDIRS))
BUILD_STAMPS = $(addprefix $(STAMP_DIR)/build-,$(SUBDIRS))
%:
dh $@ --with autoreconf,quilt --parallel
dh $@ --with quilt
debian/autoreconf:
echo $(SUBDIRS) > $@
@ -56,7 +54,10 @@ override_dh_auto_install:
done
override_dh_install:
dh_install -Xrgb.txt --fail-missing
dh_install -Xrgb.txt
override_dh_missing:
dh_missing --fail-missing
.PHONY: get-tarballs
get-tarballs: $(addprefix get-tarball-,$(SUBDIRS))

View File

@ -1,32 +0,0 @@
#!/bin/sh
set -e
if ! [ -d debian/prune ]; then
exit 0
fi
if [ "x$1" != x--upstream-version ]; then
exit 1
fi
version="$2"
filename="$3"
if [ -z "$version" ] || ! [ -f "$filename" ]; then
exit 1
fi
dir="$(pwd)"
tempdir="$(mktemp -d)"
cd "$tempdir"
tar xf "$dir/$filename"
cat "$dir"/debian/prune/* | while read file; do rm -f */$file; done
tar czf "$dir/$filename" *
cd "$dir"
rm -rf "$tempdir"
echo "Done pruning upstream tarball"
exit 0

285
debian/xsfbs/xsfbs.mk vendored
View File

@ -1,285 +0,0 @@
#!/usr/bin/make -f
# Debian X Strike Force Build System (XSFBS): Make portion
# Copyright 1996 Stephen Early
# Copyright 1997 Mark Eichin
# Copyright 1998-2005, 2007 Branden Robinson
# Copyright 2005 David Nusinow
#
# Licensed under the GNU General Public License, version 2. See the file
# /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
# Originally by Stephen Early <sde1000@debian.org>
# Modified by Mark W. Eichin <eichin@kitten.gen.ma.us>
# Modified by Adam Heath <doogie@debian.org>
# Modified by Branden Robinson <branden@debian.org>
# Modified by Fabio Massimo Di Nitto <fabbione@fabbione.net>
# Modified by David Nusinow <dnusinow@debian.org>
# Acknowledgements to Manoj Srivastava.
# Pass $(DH_OPTIONS) into the environment for debhelper's benefit.
export DH_OPTIONS
# force quilt to not use ~/.quiltrc and to use debian/patches
QUILT = QUILT_PATCHES=debian/patches quilt --quiltrc /dev/null
# Set up parameters for the upstream build environment.
# Determine (source) package name from Debian changelog.
SOURCE_NAME:=$(shell dpkg-parsechangelog -ldebian/changelog \
| grep '^Source:' | awk '{print $$2}')
# Determine package version from Debian changelog.
SOURCE_VERSION:=$(shell dpkg-parsechangelog -ldebian/changelog \
| grep '^Version:' | awk '{print $$2}')
# Determine upstream version number.
UPSTREAM_VERSION:=$(shell echo $(SOURCE_VERSION) | sed 's/-.*//')
# Determine the source version without the epoch for make-orig-tar-gz
NO_EPOCH_VER:=$(shell echo $(UPSTREAM_VERSION) | sed 's/^.://')
# Figure out who's building this package.
BUILDER:=$(shell echo $${DEBEMAIL:-$${EMAIL:-$$(echo $$LOGNAME@$$(cat /etc/mailname 2>/dev/null))}})
# Find out if this is an official build; an official build has nothing but
# digits, dots, and/or the codename of a release in the Debian part of the
# version number. Anything else indicates an unofficial build.
OFFICIAL_BUILD:=$(shell VERSION=$(SOURCE_VERSION); if ! expr "$$(echo $${VERSION\#\#*-} | sed 's/\(woody\|sarge\|etch\|lenny\)//g')" : ".*[^0-9.].*" >/dev/null 2>&1; then echo yes; fi)
# Set up parameters for the Debian build environment.
# Determine our architecture.
BUILD_ARCH:=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
# Work around some old-time dpkg braindamage.
BUILD_ARCH:=$(subst i486,i386,$(BUILD_ARCH))
# The DEB_HOST_ARCH variable may be set per the Debian cross-compilation policy.
ifdef DEB_HOST_ARCH
ARCH:=$(DEB_HOST_ARCH)
else
# dpkg-cross sets the ARCH environment variable; if set, use it.
ifdef ARCH
ARCH:=$(ARCH)
else
ARCH:=$(BUILD_ARCH)
endif
endif
# $(STAMP_DIR) houses stamp files for complex targets.
STAMP_DIR:=stampdir
# $(DEBTREEDIR) is where all install rules are told (via $(DESTDIR)) to place
# their files.
DEBTREEDIR:=$(CURDIR)/debian/tmp
# All "important" targets have four lines:
# 1) A target name that is invoked by a package-building tool or the user.
# This consists of a dependency on a "$(STAMP_DIR)/"-prefixed counterpart.
# 2) A line delcaring 1) as a phony target (".PHONY:").
# 3) A "$(STAMP_DIR)/"-prefixed target which does the actual work, and may
# depend on other targets.
# 4) A line declaring 3) as a member of the $(stampdir_targets) variable; the
# "$(STAMP_DIR)/" prefix is omitted.
#
# This indirection is needed so that the "stamp" files that signify when a rule
# is done can be located in a separate "stampdir". Recall that make has no way
# to know when a goal has been met for a phony target (like "build" or
# "install").
#
# At the end of each "$(STAMP_DIR)/" target, be sure to run the command ">$@"
# so that the target will not be run again. Removing the file will make Make
# run the target over.
# All phony targets should be declared as dependencies of .PHONY, even if they
# do not have "($STAMP_DIR)/"-prefixed counterparts.
# Define a harmless default rule to keep things from going nuts by accident.
.PHONY: default
default:
# Set up the $(STAMP_DIR) directory.
.PHONY: stampdir
stampdir_targets+=stampdir
stampdir: $(STAMP_DIR)/stampdir
$(STAMP_DIR)/stampdir:
mkdir $(STAMP_DIR)
>$@
# Set up the package build directory as quilt expects to find it.
.PHONY: prepare
stampdir_targets+=prepare
prepare: $(STAMP_DIR)/prepare
$(STAMP_DIR)/prepare: $(STAMP_DIR)/logdir $(STAMP_DIR)/genscripts
>$@
.PHONY: logdir
stampdir_targets+=logdir
logdir: $(STAMP_DIR)/logdir
$(STAMP_DIR)/logdir: $(STAMP_DIR)/stampdir
mkdir -p $(STAMP_DIR)/log
>$@
# Apply all patches to the upstream source.
.PHONY: patch
stampdir_targets+=patch
patch: $(STAMP_DIR)/patch
$(STAMP_DIR)/patch: $(STAMP_DIR)/prepare
if ! [ `which quilt` ]; then \
echo "Couldn't find quilt. Please install it or add it to the build-depends for this package."; \
exit 1; \
fi; \
if $(QUILT) next >/dev/null 2>&1; then \
echo -n "Applying patches..."; \
if $(QUILT) push -a -v >$(STAMP_DIR)/log/patch 2>&1; then \
cat $(STAMP_DIR)/log/patch; \
echo "successful."; \
else \
cat $(STAMP_DIR)/log/patch; \
echo "failed! (check $(STAMP_DIR)/log/patch for details)"; \
exit 1; \
fi; \
else \
echo "No patches to apply"; \
fi; \
>$@
# Revert all patches to the upstream source.
.PHONY: unpatch
unpatch: $(STAMP_DIR)/logdir
rm -f $(STAMP_DIR)/patch
@echo -n "Unapplying patches..."; \
if $(QUILT) applied >/dev/null 2>/dev/null; then \
if $(QUILT) pop -a -v >$(STAMP_DIR)/log/unpatch 2>&1; then \
cat $(STAMP_DIR)/log/unpatch; \
echo "successful."; \
else \
cat $(STAMP_DIR)/log/unpatch; \
echo "failed! (check $(STAMP_DIR)/log/unpatch for details)"; \
exit 1; \
fi; \
else \
echo "nothing to do."; \
fi
# Clean the generated maintainer scripts.
.PHONY: cleanscripts
cleanscripts:
rm -f $(STAMP_DIR)/genscripts
rm -f debian/*.config \
debian/*.postinst \
debian/*.postrm \
debian/*.preinst \
debian/*.prerm
# Clean the package build tree.
.PHONY: xsfclean
xsfclean: cleanscripts unpatch
dh_testdir
rm -rf .pc
rm -rf $(STAMP_DIR)
dh_clean
# Remove files from the upstream source tree that we don't need, or which have
# licensing problems. It must be run before creating the .orig.tar.gz.
#
# Note: This rule is for Debian package maintainers' convenience, and is not
# needed for conventional build scenarios.
.PHONY: prune-upstream-tree
prune-upstream-tree:
# Ensure we're in the correct directory.
dh_testdir
grep -rvh '^#' debian/prune/ | xargs --no-run-if-empty rm -rf
# Verify that there are no offsets or fuzz in the patches we apply.
#
# Note: This rule is for Debian package maintainers' convenience, and is not
# needed for conventional build scenarios.
.PHONY: patch-audit
patch-audit: prepare unpatch
@echo -n "Auditing patches..."; \
>$(STAMP_DIR)/log/patch; \
FUZZY=; \
while [ -n "$$($(QUILT) next)" ]; do \
RESULT=$$($(QUILT) push -v | tee -a $(STAMP_DIR)/log/patch | grep ^Hunk | sed 's/^Hunk.*\(succeeded\|FAILED\).*/\1/');\
case "$$RESULT" in \
succeeded) \
echo "fuzzy patch: $$($(QUILT) top)" \
| tee -a $(STAMP_DIR)/log/$$($(QUILT) top); \
FUZZY=yes; \
;; \
FAILED) \
echo "broken patch: $$($(QUILT) next)" \
| tee -a $(STAMP_DIR)/log/$$($(QUILT) next); \
exit 1; \
;; \
esac; \
done; \
if [ -n "$$FUZZY" ]; then \
echo "there were fuzzy patches; please fix."; \
exit 1; \
else \
echo "done."; \
fi
# Generate the maintainer scripts.
.PHONY: genscripts
stampdir_targets+=genscripts
genscripts: $(STAMP_DIR)/genscripts
$(STAMP_DIR)/genscripts: $(STAMP_DIR)/stampdir
for FILE in debian/*.config.in \
debian/*.postinst.in \
debian/*.postrm.in \
debian/*.preinst.in \
debian/*.prerm.in; do \
if [ -e "$$FILE" ]; then \
MAINTSCRIPT=$$(echo $$FILE | sed 's/.in$$//'); \
sed -n '1,/^#INCLUDE_SHELL_LIB#$$/p' <$$FILE \
| sed -e '/^#INCLUDE_SHELL_LIB#$$/d' >$$MAINTSCRIPT.tmp; \
cat debian/xsfbs/xsfbs.sh >>$$MAINTSCRIPT.tmp; \
sed -n '/^#INCLUDE_SHELL_LIB#$$/,$$p' <$$FILE \
| sed -e '/^#INCLUDE_SHELL_LIB#$$/d' >>$$MAINTSCRIPT.tmp; \
sed -e 's/@SOURCE_VERSION@/$(SOURCE_VERSION)/' \
-e 's/@OFFICIAL_BUILD@/$(OFFICIAL_BUILD)/' \
<$$MAINTSCRIPT.tmp >$$MAINTSCRIPT; \
rm $$MAINTSCRIPT.tmp; \
fi; \
done
# Validate syntax of generated shell scripts.
#sh debian/scripts/validate-posix-sh debian/*.config \
# debian/*.postinst \
# debian/*.postrm \
# debian/*.preinst \
# debian/*.prerm
>$@
# Compute dependencies for drivers
#
VIDEODEP = $(shell cat /usr/share/xserver-xorg/videodrvdep 2>/dev/null)
INPUTDEP = $(shell cat /usr/share/xserver-xorg/xinputdep 2>/dev/null)
# these two can be removed post-squeeze
VIDEOABI = $(shell cat /usr/share/xserver-xorg/videoabiver 2>/dev/null)
INPUTABI = $(shell cat /usr/share/xserver-xorg/inputabiver 2>/dev/null)
VIDDRIVER_PROVIDES = xserver-xorg-video-$(VIDEOABI), xorg-driver-video
INPDRIVER_PROVIDES = xserver-xorg-input-$(INPUTABI), xorg-driver-input
ifeq ($(PACKAGE),)
PACKAGE=$(shell awk '/^Package:/ { print $$2; exit }' < debian/control)
endif
.PHONY: serverabi
serverabi: install
ifeq ($(VIDEODEP),)
@echo 'error: xserver-xorg-dev >= 1.7.6.901 needs to be installed'
@exit 1
else
echo "xviddriver:Depends=$(VIDEODEP)" >> debian/$(PACKAGE).substvars
echo "xinpdriver:Depends=$(INPUTDEP)" >> debian/$(PACKAGE).substvars
# the following is there for compatibility...
echo "xviddriver:Provides=$(VIDDRIVER_PROVIDES)" >> debian/$(PACKAGE).substvars
echo "xinpdriver:Provides=$(INPDRIVER_PROVIDES)" >> debian/$(PACKAGE).substvars
echo "xserver:Depends=$(VIDEODEP), $(INPUTDEP)" >> debian/$(PACKAGE).substvars
endif
# vim:set noet ai sts=8 sw=8 tw=0:

622
debian/xsfbs/xsfbs.sh vendored
View File

@ -1,622 +0,0 @@
# This is the X Strike Force shell library for X Window System package
# maintainer scripts. It serves to define shell functions commonly used by
# such packages, and performs some error checking necessary for proper operation
# of those functions. By itself, it does not "do" much; the maintainer scripts
# invoke the functions defined here to accomplish package installation and
# removal tasks.
# If you are reading this within a Debian package maintainer script (e.g.,
# /var/lib/dpkg/info/PACKAGE.{config,preinst,postinst,prerm,postrm}), you can
# skip past this library by scanning forward in this file to the string
# "GOBSTOPPER".
SOURCE_VERSION=@SOURCE_VERSION@
OFFICIAL_BUILD=@OFFICIAL_BUILD@
# Use special abnormal exit codes so that problems with this library are more
# easily tracked down.
SHELL_LIB_INTERNAL_ERROR=86
SHELL_LIB_THROWN_ERROR=74
SHELL_LIB_USAGE_ERROR=99
# old -> new variable names
if [ -z "$DEBUG_XORG_PACKAGE" ] && [ -n "$DEBUG_XFREE86_PACKAGE" ]; then
DEBUG_XORG_PACKAGE="$DEBUG_XFREE86_PACKAGE"
fi
if [ -z "$DEBUG_XORG_DEBCONF" ] && [ -n "$DEBUG_XFREE86_DEBCONF" ]; then
DEBUG_XORG_DEBCONF="$DEBUG_XFREE86_DEBCONF"
fi
# initial sanity checks
if [ -z "$THIS_PACKAGE" ]; then
cat >&2 <<EOF
Error: package maintainer script attempted to use shell library without
definining \$THIS_PACKAGE shell variable. Please report the package name,
version, and the text of this error message to the Debian Bug Tracking System.
Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
"doc-debian" package, or install the "reportbug" package and use the command of
the same name to file a report against version $SOURCE_VERSION of this package.
EOF
exit $SHELL_LIB_USAGE_ERROR
fi
if [ -z "$THIS_SCRIPT" ]; then
cat >&2 <<EOF
Error: package maintainer script attempted to use shell library without
definining \$THIS_SCRIPT shell variable. Please report the package name,
version, and the text of this error message to the Debian Bug Tracking System.
Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
"doc-debian" package, or install the "reportbug" package and use the command of
the same name to file a report against version $SOURCE_VERSION of the
"$THIS_PACKAGE" package.
EOF
exit $SHELL_LIB_USAGE_ERROR
fi
if [ "$1" = "reconfigure" ] || [ -n "$DEBCONF_RECONFIGURE" ]; then
RECONFIGURE="true"
else
RECONFIGURE=
fi
if ([ "$1" = "install" ] || [ "$1" = "configure" ]) && [ -z "$2" ]; then
FIRSTINST="yes"
fi
if [ -z "$RECONFIGURE" ] && [ -z "$FIRSTINST" ]; then
UPGRADE="yes"
fi
trap "message;\
message \"Received signal. Aborting $THIS_PACKAGE package $THIS_SCRIPT script.\";\
message;\
exit 1" HUP INT QUIT TERM
reject_nondigits () {
# syntax: reject_nondigits [ operand ... ]
#
# scan operands (typically shell variables whose values cannot be trusted) for
# characters other than decimal digits and barf if any are found
while [ -n "$1" ]; do
# does the operand contain anything but digits?
if ! expr "$1" : "[[:digit:]]\+$" > /dev/null 2>&1; then
# can't use die(), because it wraps message() which wraps this function
echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_nondigits() encountered" \
"possibly malicious garbage \"$1\"" >&2
exit $SHELL_LIB_THROWN_ERROR
fi
shift
done
}
reject_unlikely_path_chars () {
# syntax: reject_unlikely_path_chars [ operand ... ]
#
# scan operands (typically shell variables whose values cannot be trusted) for
# characters unlikely to be seen in a path and which the shell might
# interpret and barf if any are found
while [ -n "$1" ]; do
# does the operand contain any funny characters?
if expr "$1" : '.*[!$&()*;<>?|].*' > /dev/null 2>&1; then
# can't use die(), because I want to avoid forward references
echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_unlikely_path_chars()" \
"encountered possibly malicious garbage \"$1\"" >&2
exit $SHELL_LIB_THROWN_ERROR
fi
shift
done
}
# Query the terminal to establish a default number of columns to use for
# displaying messages to the user. This is used only as a fallback in the
# event the COLUMNS variable is not set. ($COLUMNS can react to SIGWINCH while
# the script is running, and this cannot, only being calculated once.)
DEFCOLUMNS=$(stty size 2> /dev/null | awk '{print $2}') || true
if ! expr "$DEFCOLUMNS" : "[[:digit:]]\+$" > /dev/null 2>&1; then
DEFCOLUMNS=80
fi
message () {
# pretty-print messages of arbitrary length
reject_nondigits "$COLUMNS"
echo "$*" | fmt -t -w ${COLUMNS:-$DEFCOLUMNS} >&2
}
observe () {
# syntax: observe message ...
#
# issue observational message suitable for logging someday when support for
# it exists in dpkg
if [ -n "$DEBUG_XORG_PACKAGE" ]; then
message "$THIS_PACKAGE $THIS_SCRIPT note: $*"
fi
}
warn () {
# syntax: warn message ...
#
# issue warning message suitable for logging someday when support for
# it exists in dpkg; also send to standard error
message "$THIS_PACKAGE $THIS_SCRIPT warning: $*"
}
die () {
# syntax: die message ...
#
# exit script with error message
message "$THIS_PACKAGE $THIS_SCRIPT error: $*"
exit $SHELL_LIB_THROWN_ERROR
}
internal_error () {
# exit script with error; essentially a "THIS SHOULD NEVER HAPPEN" message
message "internal error: $*"
if [ -n "$OFFICIAL_BUILD" ]; then
message "Please report a bug in the $THIS_SCRIPT script of the" \
"$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
"Tracking System. Include all messages above that mention the" \
"$THIS_PACKAGE package. Visit " \
"<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
"instructions, read the file" \
"/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
"package, or install the reportbug package and use the command of" \
"the same name to file a report."
fi
exit $SHELL_LIB_INTERNAL_ERROR
}
usage_error () {
message "usage error: $*"
message "Please report a bug in the $THIS_SCRIPT script of the" \
"$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
"Tracking System. Include all messages above that mention the" \
"$THIS_PACKAGE package. Visit " \
"<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
"instructions, read the file" \
"/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
"package, or install the reportbug package and use the command of" \
"the same name to file a report."
exit $SHELL_LIB_USAGE_ERROR
}
font_update () {
# run $UPDATECMDS in $FONTDIRS
local dir cmd shortcmd x_font_dir_prefix
x_font_dir_prefix="/usr/share/fonts/X11"
if [ -z "$UPDATECMDS" ]; then
usage_error "font_update() called but \$UPDATECMDS not set"
fi
if [ -z "$FONTDIRS" ]; then
usage_error "font_update() called but \$FONTDIRS not set"
fi
reject_unlikely_path_chars "$UPDATECMDS"
reject_unlikely_path_chars "$FONTDIRS"
for dir in $FONTDIRS; do
if [ -d "$x_font_dir_prefix/$dir" ]; then
for cmd in $UPDATECMDS; do
if which "$cmd" > /dev/null 2>&1; then
shortcmd=${cmd##*/}
observe "running $shortcmd in $dir font directory"
cmd_opts=
if [ "$shortcmd" = "update-fonts-alias" ]; then
cmd_opts=--x11r7-layout
fi
if [ "$shortcmd" = "update-fonts-dir" ]; then
cmd_opts=--x11r7-layout
fi
if [ "$shortcmd" = "update-fonts-scale" ]; then
cmd_opts=--x11r7-layout
fi
$cmd $cmd_opts $dir || warn "$cmd $cmd_opts $dir" \
"failed; font directory data may not" \
"be up to date"
else
warn "$cmd not found; not updating corresponding $dir font" \
"directory data"
fi
done
else
warn "$dir is not a directory; not updating font directory data"
fi
done
}
remove_conffile_prepare () {
# syntax: remove_conffile_prepare filename official_md5sum ...
#
# Check a conffile "filename" against a list of canonical MD5 checksums.
# If the file's current MD5 checksum matches one of the "official_md5sum"
# operands provided, then prepare the conffile for removal from the system.
# We defer actual deletion until the package is configured so that we can
# roll this operation back if package installation fails.
#
# Call this function from a preinst script in the event $1 is "upgrade" or
# "install" and verify $2 to ensure the package is being upgraded from a
# version (or installed over a version removed-but-not-purged) prior to the
# one in which the conffile was obsoleted.
local conffile current_checksum
# validate arguments
if [ $# -lt 2 ]; then
usage_error "remove_conffile_prepare() called with wrong number of" \
"arguments; expected at least 2, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
conffile="$1"
shift
# does the conffile even exist?
if [ -e "$conffile" ]; then
# calculate its checksum
current_checksum=$(md5sum < "$conffile" | sed 's/[[:space:]].*//')
# compare it to each supplied checksum
while [ -n "$1" ]; do
if [ "$current_checksum" = "$1" ]; then
# we found a match; move the confffile and stop looking
observe "preparing obsolete conffile $conffile for removal"
mv "$conffile" "$conffile.$THIS_PACKAGE-tmp"
break
fi
shift
done
fi
}
remove_conffile_lookup () {
# syntax: remove_conffile_lookup package filename
#
# Lookup the md5sum of a conffile in dpkg's database, and prepare for removal
# if it matches the actual file's md5sum.
#
# Call this function when you would call remove_conffile_prepare but only
# want to check against dpkg's status database instead of known checksums.
local package conffile old_md5sum
# validate arguments
if [ $# -ne 2 ]; then
usage_error "remove_conffile_lookup() called with wrong number of" \
"arguments; expected 1, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
package="$1"
conffile="$2"
if ! [ -e "$conffile" ]; then
return
fi
old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$package" | \
awk '{ if (match($0, "^ '"$conffile"' ")) print $2}')"
if [ -n "$old_md5sum" ]; then
remove_conffile_prepare "$conffile" "$old_md5sum"
fi
}
remove_conffile_commit () {
# syntax: remove_conffile_commit filename
#
# Complete the removal of a conffile "filename" that has become obsolete.
#
# Call this function from a postinst script after having used
# remove_conffile_prepare() in the preinst.
local conffile
# validate arguments
if [ $# -ne 1 ]; then
usage_error "remove_conffile_commit() called with wrong number of" \
"arguments; expected 1, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
conffile="$1"
# if the temporary file created by remove_conffile_prepare() exists, remove it
if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
observe "committing removal of obsolete conffile $conffile"
rm "$conffile.$THIS_PACKAGE-tmp"
fi
}
remove_conffile_rollback () {
# syntax: remove_conffile_rollback filename
#
# Roll back the removal of a conffile "filename".
#
# Call this function from a postrm script in the event $1 is "abort-upgrade"
# or "abort-install" is after having used remove_conffile_prepare() in the
# preinst.
local conffile
# validate arguments
if [ $# -ne 1 ]; then
usage_error "remove_conffile_rollback() called with wrong number of" \
"arguments; expected 1, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
conffile="$1"
# if the temporary file created by remove_conffile_prepare() exists, move it
# back
if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
observe "rolling back removal of obsolete conffile $conffile"
mv "$conffile.$THIS_PACKAGE-tmp" "$conffile"
fi
}
replace_conffile_with_symlink_prepare () {
# syntax: replace_conffile_with_symlink_prepare oldfilename newfilename \
# official_md5sum ...
#
# Check a conffile "oldfilename" against a list of canonical MD5 checksums.
# If the file's current MD5 checksum matches one of the "official_md5sum"
# operands provided, then prepare the conffile for removal from the system.
# We defer actual deletion until the package is configured so that we can
# roll this operation back if package installation fails. Otherwise copy it
# to newfilename and let dpkg handle it through conffiles mechanism.
#
# Call this function from a preinst script in the event $1 is "upgrade" or
# "install" and verify $2 to ensure the package is being upgraded from a
# version (or installed over a version removed-but-not-purged) prior to the
# one in which the conffile was obsoleted.
local conffile current_checksum
# validate arguments
if [ $# -lt 3 ]; then
usage_error "replace_conffile_with_symlink_prepare() called with wrong" \
" number of arguments; expected at least 3, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
oldconffile="$1"
shift
newconffile="$1"
shift
remove_conffile_prepare "$_oldconffile" "$@"
# If $oldconffile still exists, then md5sums didn't match.
# Copy it to new one.
if [ -f "$oldconffile" ]; then
cp "$oldconffile" "$newconffile"
fi
}
replace_conffile_with_symlink_commit () {
# syntax: replace_conffile_with_symlink_commit oldfilename
#
# Complete the removal of a conffile "oldfilename" that has been
# replaced by a symlink.
#
# Call this function from a postinst script after having used
# replace_conffile_with_symlink_prepare() in the preinst.
local conffile
# validate arguments
if [ $# -ne 1 ]; then
usage_error "replace_conffile_with_symlink_commit() called with wrong" \
"number of arguments; expected 1, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
conffile="$1"
remove_conffile_commit "$conffile"
}
replace_conffile_with_symlink_rollback () {
# syntax: replace_conffile_with_symlink_rollback oldfilename newfilename
#
# Roll back the replacing of a conffile "oldfilename" with symlink to
# "newfilename".
#
# Call this function from a postrm script in the event $1 is "abort-upgrade"
# or "abort-install" and verify $2 to ensure the package failed to upgrade
# from a version (or install over a version removed-but-not-purged) prior
# to the one in which the conffile was obsoleted.
# You should have used replace_conffile_with_symlink_prepare() in the
# preinst.
local conffile
# validate arguments
if [ $# -ne 2 ]; then
usage_error "replace_conffile_with_symlink_rollback() called with wrong" \
"number of arguments; expected 2, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
oldconffile="$1"
newconffile="$2"
remove_conffile_rollback "$_oldconffile"
if [ -f "$newconffile" ]; then
rm "$newconffile"
fi
}
run () {
# syntax: run command [ argument ... ]
#
# Run specified command with optional arguments and report its exit status.
# Useful for commands whose exit status may be nonzero, but still acceptable,
# or commands whose failure is not fatal to us.
#
# NOTE: Do *not* use this function with db_get or db_metaget commands; in
# those cases the return value of the debconf command *must* be checked
# before the string returned by debconf is used for anything.
local retval
# validate arguments
if [ $# -lt 1 ]; then
usage_error "run() called with wrong number of arguments; expected at" \
"least 1, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
"$@" || retval=$?
if [ ${retval:-0} -ne 0 ]; then
observe "command \"$*\" exited with status $retval"
fi
}
make_symlink_sane () {
# syntax: make_symlink_sane symlink target
#
# Ensure that the symbolic link symlink exists, and points to target.
#
# If symlink does not exist, create it and point it at target.
#
# If symlink exists but is not a symbolic link, back it up.
#
# If symlink exists, is a symbolic link, but points to the wrong location, fix
# it.
#
# If symlink exists, is a symbolic link, and already points to target, do
# nothing.
#
# This function wouldn't be needed if ln had an -I, --idempotent option.
# Validate arguments.
if [ $# -ne 2 ]; then
usage_error "make_symlink_sane() called with wrong number of arguments;" \
"expected 2, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
# We could just use the positional parameters as-is, but that makes things
# harder to follow.
local symlink target
symlink="$1"
target="$2"
if [ -L "$symlink" ] && [ "$(readlink "$symlink")" = "$target" ]; then
observe "link from $symlink to $target already exists"
else
observe "creating symbolic link from $symlink to $target"
mkdir -p "${target%/*}" "${symlink%/*}"
ln -s -b -S ".dpkg-old" "$target" "$symlink"
fi
}
migrate_dir_to_symlink () {
# syntax: migrate_dir_to_symlink old_location new_location
#
# Per Debian Policy section 6.5.4, "A directory will never be replaced by a
# symbolic link to a directory or vice versa; instead, the existing state
# (symlink or not) will be left alone and dpkg will follow the symlink if
# there is one."
#
# We have to do it ourselves.
#
# This function moves the contents of old_location, a directory, into
# new_location, a directory, then makes old_location a symbolic link to
# new_location.
#
# old_location need not exist, but if it does, it must be a directory (or a
# symlink to a directory). If it is not, it is backed up. If new_location
# exists already and is not a directory, it is backed up.
#
# This function should be called from a package's preinst so that other
# packages unpacked after this one --- but before this package's postinst runs
# --- are unpacked into new_location even if their payloads contain
# old_location filespecs.
# Validate arguments.
if [ $# -ne 2 ]; then
usage_error "migrate_dir_to_symlink() called with wrong number of"
"arguments; expected 2, got $#"
exit $SHELL_LIB_USAGE_ERROR
fi
# We could just use the positional parameters as-is, but that makes things
# harder to follow.
local new old
old="$1"
new="$2"
# Is old location a symlink?
if [ -L "$old" ]; then
# Does it already point to new location?
if [ "$(readlink "$old")" = "$new" ]; then
# Nothing to do; migration has already been done.
observe "migration of $old to $new already done"
return 0
else
# Back it up.
warn "backing up symbolic link $old as $old.dpkg-old"
mv -b "$old" "$old.dpkg-old"
fi
fi
# Does old location exist, but is not a directory?
if [ -e "$old" ] && ! [ -d "$old" ]; then
# Back it up.
warn "backing up non-directory $old as $old.dpkg-old"
mv -b "$old" "$old.dpkg-old"
fi
observe "migrating $old to $new"
# Is new location a symlink?
if [ -L "$new" ]; then
# Does it point the wrong way, i.e., back to where we're migrating from?
if [ "$(readlink "$new")" = "$old" ]; then
# Get rid of it.
observe "removing symbolic link $new which points to $old"
rm "$new"
else
# Back it up.
warn "backing up symbolic link $new as $new.dpkg-old"
mv -b "$new" "$new.dpkg-old"
fi
fi
# Does new location exist, but is not a directory?
if [ -e "$new" ] && ! [ -d "$new" ]; then
warn "backing up non-directory $new as $new.dpkg-old"
mv -b "$new" "$new.dpkg-old"
fi
# Create new directory if it does not yet exist.
if ! [ -e "$new" ]; then
observe "creating $new"
mkdir -p "$new"
fi
# Copy files in old location to new location. Back up any filenames that
# already exist in the new location with the extension ".dpkg-old".
observe "copying files from $old to $new"
if ! (cd "$old" && cp -a -b -S ".dpkg-old" . "$new"); then
die "error(s) encountered while copying files from $old to $new"
fi
# Remove files at old location.
observe "removing $old"
rm -r "$old"
# Create symlink from old location to new location.
make_symlink_sane "$old" "$new"
}
# vim:set ai et sw=2 ts=2 tw=80:
# GOBSTOPPER: The X Strike Force shell library ends here.